"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var QueryString = require("querystring");
/**
 * 浏览器端的HttpClient
 * 移除proxy
 */
var HttpClient = /** @class */ (function () {
    function HttpClient() {
    }
    HttpClient.put = function (url, formData) {
        if (formData === void 0) { formData = {}; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var xhr = new XMLHttpRequest();
                        xhr.addEventListener("loadend", function (event) {
                            if (xhr.status === 200) {
                                resolve(xhr);
                            }
                            else {
                                reject(event);
                            }
                        });
                        xhr.addEventListener("error", function (event) {
                            reject(event);
                        });
                        xhr.addEventListener("progress", function () {
                        });
                        xhr.addEventListener("abort", function (event) {
                            reject(event);
                        });
                        xhr.open("PUT", url);
                        xhr.setRequestHeader("Content-type", "application/json");
                        xhr.send(JSON.stringify(formData));
                    })];
            });
        });
    };
    HttpClient["delete"] = function (url, formData) {
        if (formData === void 0) { formData = {}; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var xhr = new XMLHttpRequest();
                        xhr.addEventListener("loadend", function (event) {
                            if (xhr.status === 200) {
                                resolve(xhr);
                            }
                            else {
                                reject(event);
                            }
                        });
                        xhr.addEventListener("error", function (event) {
                            reject(event);
                        });
                        xhr.addEventListener("progress", function () {
                        });
                        xhr.addEventListener("abort", function (event) {
                            reject(event);
                        });
                        xhr.open("DELETE", url);
                        xhr.setRequestHeader("Content-type", "application/json");
                        xhr.send(JSON.stringify(formData));
                    })];
            });
        });
    };
    /**
     * Post用这种方法，主要是提交json数据。但是对于非json数据的文件上传，还需要编写upload方法，以便支持流式上传
     * 添加返回值类型，允许进行格式化
     * @param url
     * @param formData
     * @param type
     */
    HttpClient.post = function (url, formData) {
        if (formData === void 0) { formData = {}; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var xhr = new XMLHttpRequest();
                        xhr.addEventListener("loadend", function (event) {
                            if (xhr.status === 200) {
                                resolve(xhr);
                            }
                            else {
                                reject(event);
                            }
                        });
                        xhr.addEventListener("error", function (event) {
                            reject(event);
                        });
                        xhr.addEventListener("progress", function () {
                        });
                        xhr.addEventListener("abort", function (event) {
                            reject(event);
                        });
                        try {
                            xhr.open("POST", url);
                            if (formData instanceof Uint8Array) {
                                xhr.setRequestHeader("Content-type", "application/protobuf");
                                // xhr.setRequestHeader("Content-Length", String(formData.byteLength))
                                xhr.send(formData);
                            }
                            else {
                                xhr.setRequestHeader("Content-type", "application/json");
                                xhr.send(JSON.stringify(formData));
                            }
                        }
                        catch (error) {
                            reject(error);
                        }
                    })];
            });
        });
    };
    HttpClient.get = function (url, query, encode) {
        if (query === void 0) { query = null; }
        if (encode === void 0) { encode = "json"; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var xhr;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (query !== null) {
                            url += QueryString.stringify(query);
                        }
                        return [4 /*yield*/, HttpClient.getXMLHttpRequest(url)];
                    case 1:
                        xhr = _a.sent();
                        switch (encode) {
                            case "json":
                                return [2 /*return*/, JSON.parse(xhr.responseText)];
                            case "text":
                                return [2 /*return*/, xhr.responseText];
                            case "xhr":
                                return [2 /*return*/, xhr];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 将url获取前面path和host部分
     */
    HttpClient.getURL = function () {
    };
    /**
     * 将url解析成querystring
     */
    HttpClient.getQuery = function (url) {
    };
    /**
     * 将cookies解析成cookies
     */
    HttpClient.getCookiesByString = function (cookie) {
    };
    HttpClient.getXMLHttpRequest = function (url) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var xhr = new XMLHttpRequest();
                        xhr.addEventListener("loadend", function (event) {
                            if (xhr.status === 200) {
                                resolve(xhr);
                            }
                            else {
                                reject(event);
                            }
                        });
                        xhr.addEventListener("error", function (event) {
                            reject(event);
                        });
                        xhr.addEventListener("progress", function () {
                        });
                        xhr.addEventListener("abort", function (event) {
                            reject(event);
                        });
                        xhr.open("GET", url);
                        xhr.send();
                    })];
            });
        });
    };
    return HttpClient;
}());
exports.HttpClient = HttpClient;
