"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:11:29

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var LarkFatalError = /** @class */ (function () {
    /**
     * 错误
     * @param name 错误的字符串枚举，全大写加下划线开头，全局不重复
     * @param code 不重复的错误码
     * @param message 简短的对错误的信息进行描述
     */
    function LarkFatalError(message, data, code, name) {
        if (message === void 0) { message = ""; }
        if (data === void 0) { data = null; }
        if (code === void 0) { code = -1; }
        if (name === void 0) { name = "LarkFatalError"; }
        this.code = -1;
        this.data = null;
        this.name = "LarkFatalError";
        this.message = null;
        this.stack = null;
        this.name = name;
        this.message = message;
        this.name = name;
        this.code = code;
        this.data = data;
        this.stack = new Error().stack;
    }
    LarkFatalError.prototype["throw"] = function () {
        throw this;
    };
    return LarkFatalError;
}());
exports.LarkFatalError = LarkFatalError;
