"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:14:39

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var fs = require("fs-extra");
var SingleLineLog = require("single-line-log");
var util = require("util");
var LarkDate_1 = require("../Utils/LarkDate");
var LarkString_1 = require("../Utils/LarkString");
var LoggerDto_1 = require("./LarkLogger/LoggerDto");
var logger = console;
var LarkLogger = /** @class */ (function () {
    function LarkLogger(category) {
        if (category === void 0) { category = "default"; }
        this.category = "default";
        this.requestID = null;
        this.category = category;
        fs.ensureDirSync("./logs");
    }
    LarkLogger.prototype.single = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        // const info = this.getStringify(argv)
        // info.data.unshift(info.message)
        // info.data.push["\n"]
        SingleLineLog.stdout.apply(SingleLineLog.stdout, argv);
    };
    LarkLogger.prototype.percent = function (title, index, total, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var log, p, pIndex, percent;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log = [title];
                        p = Math.floor((index / total) * 100);
                        pIndex = Math.floor(p);
                        percent = "\u3010" + LarkString_1.LarkString.pad(pIndex, "#") + LarkString_1.LarkString.pad(100 - pIndex, "-") + "\u3011";
                        log.push(percent);
                        log.push(p + "%");
                        log.push(index + "/" + total);
                        log.push(message);
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, log)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.log = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.LOG, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.warn = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.WARN, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.info = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.error = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.ERROR, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.fatal = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.FATAL, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.trace = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // if (yargv.verbose) {
                    return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.TRACE, argv)];
                    case 1:
                        // if (yargv.verbose) {
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.infoIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.errorIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.ERROR, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.warnIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.WARN, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.logIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.LOG, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.debugIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.DEBUG, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.traceIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // if (yargv.verbose) {
                    return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.TRACE, argv)];
                    case 1:
                        // if (yargv.verbose) {
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.getStringify = function (data) {
        var m = "";
        if (typeof data[0] === "string") {
            m = data.shift();
        }
        // const a = {
        //   data,
        //   message: m,
        // };
        var tmp = [];
        for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
            var item = data_1[_i];
            var message = null;
            if (item instanceof Date) {
                message = item.toString();
            }
            else if (item instanceof Buffer) {
                message = { type: "buffer" };
            }
            else if (typeof item === "object") {
                message = JSON.stringify(util.inspect(item));
            }
            else {
                message = JSON.stringify(item);
            }
            tmp.push(message);
        }
        var a = {
            data: tmp,
            message: m
        };
        return a;
    };
    LarkLogger.prototype.output = function (level, argv) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var s, log, content;
            return tslib_1.__generator(this, function (_a) {
                s = this.getStringify(argv);
                log = {};
                log.createDatetime = new Date();
                log.category = this.category;
                log.level = level;
                log.message = s.message;
                log.data = s.data;
                log.platform = LoggerDto_1.PLATFORM.SERVER;
                content = LarkDate_1.LarkDate.format(new Date(log.createDatetime), "yyyy-MM-dd hh:mm:ss.uuu") + " " +
                    ("[" + LoggerDto_1.LOGGER_LEVEL[log.level].toUpperCase() + "]\t") +
                    (this.category + " - " + (this.requestID ? this.requestID : "") + " " + log.message + " " + log.data.join(" ").replace(/\\n|\"/g, ""));
                fs.appendFile("./logs/lark." + LarkDate_1.LarkDate.format(new Date(log.createDatetime), "yyyy-MM-dd_hh") + ".log", content + "\n");
                switch (log.level) {
                    case LoggerDto_1.LOGGER_LEVEL.INFO:
                        logger.info("" + LoggerDto_1.ILoggerColor.FgGreen + content + LoggerDto_1.ILoggerColor.Reset);
                        break;
                    case LoggerDto_1.LOGGER_LEVEL.ERROR:
                        logger.log();
                        logger.error("" + LoggerDto_1.ILoggerColor.FgRed + content + LoggerDto_1.ILoggerColor.Reset);
                        break;
                    case LoggerDto_1.LOGGER_LEVEL.WARN:
                        logger.warn("" + LoggerDto_1.ILoggerColor.FgYellow + content + LoggerDto_1.ILoggerColor.Reset);
                        break;
                    case LoggerDto_1.LOGGER_LEVEL.FATAL:
                        logger.error("" + LoggerDto_1.ILoggerColor.FgWhite + LoggerDto_1.ILoggerColor.BgRed + content + LoggerDto_1.ILoggerColor.Reset);
                        break;
                    default:
                        logger.log(content);
                }
                return [2 /*return*/];
            });
        });
    };
    return LarkLogger;
}());
exports.LarkLogger = LarkLogger;
