"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var HttpClient_1 = require("../Http/HttpClient");
var LarkLogger_1 = require("../Log/LarkLogger");
var logger = new LarkLogger_1.LarkLogger("NSQ/LarkNSQ");
var LarkNSQ = /** @class */ (function () {
    function LarkNSQ() {
    }
    /**
     * 将消息通过POST请求推送给消息服务器
     * @param topic
     * @param method
     * @param argvList
     */
    LarkNSQ.push = function (topic, method, argvList) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var message;
            return tslib_1.__generator(this, function (_a) {
                message = {
                    id: null,
                    topic: topic,
                    method: method,
                    message: argvList,
                    createDatetime: new Date()
                };
                return [2 /*return*/];
            });
        });
    };
    LarkNSQ.pull = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _i, _a, MessageClass;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _i = 0, _a = this.MessageClassList;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        MessageClass = _a[_i];
                        // console.log(MessageClass.topic)
                        return [4 /*yield*/, this.pullTopic(MessageClass)];
                    case 2:
                        // console.log(MessageClass.topic)
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    LarkNSQ.pullTopic = function (MessageClass) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var body, message;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, HttpClient_1.HttpClient.get("https://lark.51kemao.com/nsq/topic.json?topic=" + MessageClass.topic)];
                    case 1:
                        body = _a.sent();
                        message = body.message;
                        if (message === null) {
                            logger.warn("pullTopic#end", MessageClass.topic);
                            return [2 /*return*/];
                        }
                        logger.info("pullTopic#message", body, typeof message, message);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 以GET请求轮询订阅的消息
     */
    LarkNSQ.subscribe = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    /**
     * 将订阅的消息添加到队列内
     * @param MessageClass
     */
    LarkNSQ.addNSQ = function (MessageClass) {
        this.MessageClassList.push(MessageClass);
    };
    /**
     * 对消息进行更新
     * @param topic
     * @param method
     * @param message
     */
    LarkNSQ.prototype.updateMessage = function (topic, method, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    LarkNSQ.MessageClassList = [];
    return LarkNSQ;
}());
exports.LarkNSQ = LarkNSQ;
