"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:16:50

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var FileSystem = /** @class */ (function () {
    function FileSystem() {
    }
    /**
     * 9.27MB
     * 1.07MB/9.27MB
     * 10.11% 1.07MB/9.27MB
     * 是否需要增加更多尺寸比如KB/GB等等
     */
    FileSystem.getVisualFileSize = function (size) {
        return (size / (1024 * 1024)).toFixed(2) + "MB";
    };
    /**
     * 获得一个安全的文件名称
     * @param filename 待转换的文件名
     */
    FileSystem.getSafeFileName = function (filename) {
        return filename.replace(/\\|\/|\:|\*|\?|\<|\>|\||\t|\"/g, "");
    };
    FileSystem.getSafeFileNameByList = function (filenameList) {
        var list = [];
        for (var _i = 0, filenameList_1 = filenameList; _i < filenameList_1.length; _i++) {
            var item = filenameList_1[_i];
            list.push(this.getSafeFileName(item));
        }
        return list;
    };
    FileSystem.getMIMEByExtname = function (extname) {
        var mimeList = require("./FileSystem/MimeDB");
        for (var item in mimeList) {
            if (item === extname) {
                return mimeList[item];
            }
        }
        // 未能命中的数据一律以二进制返回
        return "application/octet-stream";
    };
    FileSystem.getExtnameByMIME = function (mime) {
        var mimeList = require("./FileSystem/MimeDB");
        for (var item in mimeList) {
            if (mimeList[item] === mime) {
                return item;
            }
        }
        // 未能命中的数据一律返回
        return ".dat";
    };
    return FileSystem;
}());
exports.FileSystem = FileSystem;
