"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:16:54

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var Redis = require("redis");
var logger = console;
var RedisDB = /** @class */ (function () {
    function RedisDB() {
    }
    RedisDB.set = function (category, key, value, ttl) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.init()];
                    case 1:
                        _a.sent();
                        this.redis.set(category + ":" + key, value, "EX", ttl / 1000, Redis.print);
                        return [2 /*return*/];
                }
            });
        });
    };
    RedisDB.get = function (category, key) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.init()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                _this.redis.get(category + ":" + key, function (error, record) {
                                    if (error === null) {
                                        resolve(record);
                                    }
                                    else {
                                        reject(error);
                                    }
                                });
                            })];
                }
            });
        });
    };
    RedisDB.init = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        if (_this.redis === null) {
                            var config = {
                                redis_host: "192.168.31.102",
                                redis_port: 6379,
                                ttl: 60
                            };
                            logger.log("redis", config);
                            var redis_1 = Redis.createClient({
                                host: config.redis_host,
                                port: config.redis_port,
                                db: 0,
                                prefix: "default",
                                return_buffers: true
                            });
                            redis_1.on("ready", function () {
                                _this.redis = redis_1;
                                resolve(redis_1);
                            });
                            redis_1.on("error", function (error) {
                                reject(error);
                            });
                        }
                        else {
                            resolve(_this.redis);
                        }
                    })];
            });
        });
    };
    RedisDB.redis = null;
    return RedisDB;
}());
exports.RedisDB = RedisDB;
