"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:18:01

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var fs = require("fs-extra");
var Path = require("path");
var HttpClient_1 = require("../Http/HttpClient");
var logger = console;
var LarkDOM = /** @class */ (function () {
    function LarkDOM() {
    }
    LarkDOM.getDOMList = function (sel, dom) {
        var list = [];
        var domList = dom.querySelectorAll(sel);
        for (var i = 0; i < domList.length; i++) {
            list.push(domList[i]);
        }
        return list;
    };
    LarkDOM.getTextContentList = function (sel, dom) {
        var list = [];
        var domList = this.getDOMList(sel, dom);
        for (var _i = 0, domList_1 = domList; _i < domList_1.length; _i++) {
            var domItem = domList_1[_i];
            list.push(domItem.textContent);
        }
        return list;
    };
    /**
     * 将HTML内的图片等都转换成本地
     * replace 地址处理器
     */
    LarkDOM.getLocalHTML = function (dom, assetsPath, replace) {
        if (replace === void 0) { replace = null; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var imageList, i, image, src, _a, sha1, buffer, realURL, extname, filename, filePath;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        imageList = dom.querySelectorAll("img");
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < imageList.length)) return [3 /*break*/, 4];
                        image = imageList[i];
                        src = image.getAttribute("src");
                        logger.info("img", { src: src });
                        if (typeof replace === "function") {
                            src = replace(src);
                        }
                        return [4 /*yield*/, HttpClient_1.HttpClient.getFileSHA1ByURL(src)];
                    case 2:
                        _a = _b.sent(), sha1 = _a.sha1, buffer = _a.buffer;
                        realURL = src.split("?")[0];
                        extname = Path.extname(realURL).toLowerCase();
                        logger.log({ realURL: realURL, extname: extname });
                        filename = sha1 + extname;
                        image.setAttribute("src", filename);
                        image.setAttribute("rawSrc", src);
                        filePath = assetsPath + "/" + filename;
                        logger.log({ filePath: filePath, filename: filename });
                        if (fs.existsSync(filePath) === false) {
                            fs.outputFileSync(filePath, buffer);
                        }
                        _b.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, dom.innerHTML];
                }
            });
        });
    };
    return LarkDOM;
}());
exports.LarkDOM = LarkDOM;
