"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-12-04 12:18:15

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var crypto = require("crypto");
var LarkHash = /** @class */ (function () {
    function LarkHash() {
    }
    /**
     * 获取buffer的sha1的路径
     * @param buffer
     */
    LarkHash.getBufferSHA1Path = function (buffer) {
        return this.getSHA1Path(this.getBufferSHA1(buffer));
    };
    /**
     * 获取buffer的sha1
     * @param buffer
     */
    LarkHash.getBufferSHA1 = function (buffer) {
        var input = crypto.createHash("sha1");
        input.update(buffer);
        return input.digest("hex");
    };
    LarkHash.getBufferMD5 = function (buffer) {
        var input = crypto.createHash("md5");
        input.update(buffer);
        return input.digest("hex");
    };
    /**
     * 获取流数据的sha1
     * @param stream
     */
    LarkHash.getStreamSHA1Path = function (stream) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.getSHA1Path;
                        return [4 /*yield*/, this.getStreamSHA1(stream)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    /**
     * 获取流数据的Sha1格式
     * @param stream
     */
    LarkHash.getStreamSHA1 = function (stream) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var input = crypto.createHash("sha1");
                        stream.on("data", function (chunk) {
                            input.update(chunk);
                        });
                        stream.on("error", function (error) {
                            reject(error);
                        });
                        stream.on("end", function () {
                            resolve(input.digest("hex"));
                        });
                    })];
            });
        });
    };
    /**
     * 获得SHA1的路径格式
     * @param sha1
     */
    LarkHash.getSHA1Path = function (sha1) {
        var sha1List = sha1.split("");
        return sha1List[0] + "/" + sha1List[1] + sha1List[2] + "/" + sha1;
    };
    return LarkHash;
}());
exports.LarkHash = LarkHash;
