"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-11-29 19:34:38

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOMServer = require("react-dom/server");
var HTTP_STATUS_1 = require("../../Http/HTTP_STATUS");
var Controller_1 = require("../Controller");
var LarkResponse_1 = require("../LarkResponse");
var HTML_1 = require("./ReactPageController/HTML");
var ReactPageController = /** @class */ (function (_super) {
    tslib_1.__extends(ReactPageController, _super);
    function ReactPageController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.title = null;
        // body下文的脚本
        _this.script = [];
        // 整站样式的位置
        _this.style = [];
        _this.inlineStyle = [];
        // head当中插入的脚本
        _this.headScript = [];
        _this.meta = [];
        _this.link = [];
        return _this;
    }
    ReactPageController.prototype.addStyle = function (url, remote) {
        if (remote === void 0) { remote = false; }
        this.style.push(url);
        return this;
    };
    /**
     * 设置当前uri的标题
     * @param title 标题
     */
    ReactPageController.prototype.setTitle = function (title) {
    };
    ReactPageController.prototype.addInlineStyle = function (style) {
        if (typeof style === "object") {
            style = style._getCss();
        }
        this.inlineStyle.push(style);
    };
    ReactPageController.prototype.addLink = function (link) {
        this.link.push(link);
        return this;
    };
    ReactPageController.prototype.addMeta = function (meta) {
        this.meta.push(meta);
        return this;
    };
    ReactPageController.prototype.addHeadScript = function (script) {
        this.headScript.push(script);
    };
    ReactPageController.prototype.viewport = function () {
        this.meta.push({
            content: "width=device-width, initial-scale=1, maximum-scale=1",
            name: "viewport"
        });
    };
    ReactPageController.prototype.addScript = function (href, remote) {
        if (remote === void 0) { remote = false; }
        this.script.push(href);
        return this;
    };
    ReactPageController.prototype.render = function (Component, componentProps) {
        if (componentProps === void 0) { componentProps = null; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var props, bodyElement, content, html;
            return tslib_1.__generator(this, function (_a) {
                props = {
                    headScript: this.headScript,
                    link: this.link,
                    meta: this.meta,
                    script: this.script,
                    style: this.style,
                    title: this.title
                };
                bodyElement = React.createElement(Component, componentProps);
                content = React.createElement(HTML_1.HTML, props, bodyElement);
                html = "<!doctype html>" + ReactDOMServer.renderToStaticMarkup(content);
                return [2 /*return*/, new LarkResponse_1.LarkResponse(html, HTTP_STATUS_1.HTTP_STATUS.OK, { "Content-Type": "text/html;charset=UTF-8" })];
            });
        });
    };
    return ReactPageController;
}(Controller_1.Controller));
exports.ReactPageController = ReactPageController;
