"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-11-29 19:34:44

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var fs = require("fs-extra");
var Path = require("path");
var HTTP_STATUS_1 = require("../../Http/HTTP_STATUS");
var LarkLogger_1 = require("../../Log/LarkLogger");
var Controller_1 = require("../Controller");
var LarkRequest_1 = require("../LarkRequest");
var LarkResponse_1 = require("../LarkResponse");
var NotFoundController_1 = require("./NotFoundController");
var logger = new LarkLogger_1.LarkLogger("Web/Controller/ServerStaticController");
var ServerStaticController = /** @class */ (function (_super) {
    tslib_1.__extends(ServerStaticController, _super);
    function ServerStaticController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.uri = new RegExp("/");
        _this.browserRoot = "./Browser";
        return _this;
    }
    ServerStaticController.prototype.get = function (request, requestData) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var filepath, exist, extname, content;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filepath = this.browserRoot + requestData.url.path;
                        // 注意进行路径控制，防止相对路径转换读取敏感内容
                        logger.info({ filepath: filepath }, this.browserRoot);
                        exist = fs.existsSync(filepath);
                        if (!(exist === false)) return [3 /*break*/, 2];
                        return [4 /*yield*/, new NotFoundController_1.NotFoundController().get()];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        extname = Path.extname(filepath);
                        content = fs.readFileSync(filepath);
                        return [2 /*return*/, new LarkResponse_1.LarkResponse(content, HTTP_STATUS_1.HTTP_STATUS.OK, {
                                "Content-Type": LarkRequest_1.LarkRequest.getMIMEByExtname(extname)
                            })];
                }
            });
        });
    };
    return ServerStaticController;
}(Controller_1.Controller));
exports.ServerStaticController = ServerStaticController;
