"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-11-29 19:33:12

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var tslib_1 = require("tslib");
var LarkLogger_1 = require("../Log/LarkLogger");
var FileSystem_1 = require("../Storage/FileSystem");
var LarkBuffer_1 = require("../Utils/LarkBuffer");
var logger = new LarkLogger_1.LarkLogger("LarkRequest");
var LarkRequest = /** @class */ (function () {
    function LarkRequest() {
    }
    LarkRequest.hasAcceptEncodingGZIP = function (request) {
        var accept = request["accept-encoding"];
        logger.log({ accept: accept });
        var gzip = null;
        if (typeof accept === "string") {
            var acceptList = accept.split(",");
            gzip = acceptList.indexOf("gzip") > -1;
            logger.log({ acceptList: acceptList, index: acceptList.indexOf("gzip") });
        }
        else {
            logger.log("unsupport.gzip");
            gzip = false;
        }
        logger.log({ gzip: gzip });
        return gzip;
    };
    LarkRequest.getPostBuffer = function (request) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var buffer;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, LarkBuffer_1.LarkBuffer.readBufferByStream(request)];
                    case 1:
                        buffer = _a.sent();
                        return [2 /*return*/, buffer];
                }
            });
        });
    };
    LarkRequest.getPostJSON = function (request) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var buffer;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, LarkBuffer_1.LarkBuffer.readBufferByStream(request)];
                    case 1:
                        buffer = _a.sent();
                        return [2 /*return*/, JSON.parse(buffer.toString())];
                }
            });
        });
    };
    LarkRequest.getPostString = function (request) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var buffer;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, LarkBuffer_1.LarkBuffer.readBufferByStream(request)];
                    case 1:
                        buffer = _a.sent();
                        return [2 /*return*/, buffer.toString()];
                }
            });
        });
    };
    LarkRequest.getMIMEByExtname = function (extname) {
        return FileSystem_1.FileSystem.getMIMEByExtname(extname);
    };
    return LarkRequest;
}());
exports.LarkRequest = LarkRequest;
