"use strict";
/*! *****************************************************************************
Copyright (c) JDJR Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
Author: kemao 2018-11-29 19:33:32

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
exports.__esModule = true;
var HTTP_STATUS_1 = require("../Http/HTTP_STATUS");
var LarkResponse = /** @class */ (function () {
    function LarkResponse(data, status, header, contentType) {
        if (data === void 0) { data = null; }
        if (status === void 0) { status = HTTP_STATUS_1.HTTP_STATUS.OK; }
        if (header === void 0) { header = {}; }
        this.data = null;
        this.status = 0;
        this.header = null;
        if (data === null) {
            if (status === HTTP_STATUS_1.HTTP_STATUS.OK) {
                data = { ok: true };
            }
            else {
                data = { ok: false };
            }
        }
        if (header === null) {
            header = {};
        }
        this.header = header;
        //  data;
        this.status = status;
        this.header.Server = "KemaoWebServer";
        this.header.PowerBy = "kemao";
        if (this.header["Content-Type"] === undefined) {
            if (typeof data === "string") {
                this.header["Content-Type"] = "text/plian";
            }
            if (typeof data === "object" && data instanceof Buffer) {
                this.header["Content-Type"] = "application/octet-stream";
            }
            else if (typeof data === "object") {
                this.header["Content-Type"] = "application/json";
            }
        }
        if (typeof data === "string") {
            this.data = Buffer.from(data);
        }
        else if (typeof data === "object" && data instanceof Buffer) {
            this.data = data;
        }
        else if (typeof data === "object") {
            this.data = Buffer.from(JSON.stringify(data));
        }
    }
    LarkResponse.prototype.getData = function () {
        return this.data;
    };
    return LarkResponse;
}());
exports.LarkResponse = LarkResponse;
